<template>
  <transition name="opacity">
    <div>
      <div class="h-screen" style="display: grid; grid-template: 'content' 1fr 'footer' auto / auto">
        <div
          class="md:my-8 bg-white md:rounded-lg md:shadow-lg container mx-auto lg:max-w-2/3 md:self-center"
          style="grid-area: content"
        >
          <div class="absolute top-0 right-0 z-0" style="z-index: -10">
            <img src="img/logo-bg.svg" class="w-1/3 opacity-50 m-8 float-right" />
          </div>
          <div class="font-bold flex flex-row items-center justify-start p-8 pt-16 md:pt-10">
            <img src="img/logo.svg" class="h-6 mr-4" />
            Todoninja
          </div>
          <div class="m-8 font-bold text-3xl">
            Hey!
            <div class="text-gray-600 text-base font-normal mt-4">
              You can use your email and password to log in!
            </div>
          </div>
          <error v-if="error" class="mx-8" :error="error" />
          <form @submit.prevent="submitForm()">
            <inputt
              name="Email"
              classes="pb-2 mx-8"
              placeholder="john.doe@domain.com"
              type="email"
              :value="username"
              @input="username = $event"
            ></inputt>
            <inputt
              classes="mt-4 pb-2 mx-8"
              name="Password"
              placeholder="********"
              type="password"
              :value="password"
              @input="password = $event"
            ></inputt>

            <button type="submit" class="m-8 button">
              Login
            </button>
          </form>
        </div>

        <div class="bg-blueGray-200 py-16 flex flex-row items-center justify-center self-end" style="grid-area: footer">
          Still without account? <router-link class="ml-4 link" to="/register">Create one</router-link>
        </div>
      </div>
    </div>
  </transition>
</template>

<script lang="ts">
import { Ref, ref } from "vue";
import Inputt from "@/components/Inputt.vue";
import router from "@/router";
import Message from "@/models/Message";
import Error from "@/components/Error.vue";
import { Auth } from "@/assets/Auth";

export default {
  components: { Inputt, Error },
  setup() {
    const username = ref("");
    const password = ref("");
    const error: Ref<undefined | { header: string; message: string }> = ref(undefined);

    const submitForm = () =>
      Auth.login({ username: username.value, password: password.value })
        .then(() => {
          router.push("/");
        })
        .catch(e => {
          Message.error({ title: "Login failed." }).save();
        });

    return {
      username,
      password,
      submitForm,
      error
    };
  }
};
</script>
